#include <18F4520.h>
#include <Font_rus.h>
#device CONST=ROM

#fuses HS,H4,NOWDT, WDT128, NOPROTECT, NOBROWNOUT, BORV20, PUT, NOCPD
#fuses NOSTVREN, NODEBUG, NOLVP, NOWRT, NOWRTD, NOIESO, NOFCMEN, NOPBADEN
#fuses NOWRTC, NOWRTB, NOEBTR, NOEBTRB, NOCPB, NOLPT1OSC, NOMCLR, NOXINST

#use delay(clock=20000000)    


#byte TRISD =0xF95
#byte LATD  =0xF8C
#bit  CS   = LATD.3
#bit  LED2   = LATD.2
#bit  LED1   = LATD.1
#bit  LED0   = LATD.0
#bit  RST   = LATD.7
#bit  DC    = LATD.6
#bit  SCLK  = LATD.5
#bit  SDA   = LATD.4



/*  Command Set */
#define DATCTL 0xBC         // Data Control (data handling in RAM)
#define DISCTL 0xCA         // Display Control
#define GCP64 0xCB          // pulse set for 64 gray scale
#define GCP16 0xCC          // pulse set for 16 gray scale
#define OSSEL 0xD0          // Oscillator select
#define GSSET 0xCD          // set for gray scales
#define ASCSET 0xAA         // aerea scroll setting
#define SCSTART 0xAB        // scroll start setting
#define DISON 0xAF          // Display ON (no parameter)
#define DISOFF 0xAE         // Display OFF (no parameter)
#define DISINV 0xA7         // Display Invert (no parameter)
#define DISNOR 0xA6         // Display Normal (no parameter)
#define SLPIN  0x95         // Display Sleep (no parameter)
#define SLPOUT 0x94         // Display out of sleep (no parameter)
#define RAMWR 0x5C          // Display Memory write
#define PTLIN 0xA8          // partial screen write
#define NOP     0x25 
#define SD_CSET 0x15        // column address setting
#define SD_PSET 0x75        // page address setting


#define DISP_W 132
#define DISP_H 176
#define CHAR_H 14
#define CHAR_W 8
#define TEXT_COL 16
#define TEXT_ROW 12

//#define  HIGH_COLOR     //
#define  SCREEN_COLOR   WHITE
#define  USE_GRFCN

#define  GCLCDX         176
#define  GCLCDY         732

#define  X_END          (GCLCDX-1)
#define  Y_END          (GCLCDY-1)

//Color section



#define    SKY        0x54fb
#define    BLACK    0x0000
#define    WHITE    0xFFFF
#define    GREEN    0x07E0
#define    BLUE       0x7FF0
#define    RED        0xF800
#define    YELLOW  0xDEE0
#define    ORANGE  0xAB00
#define    PINK       0xF97F
#define    BROWN   0x8200
#define    GREY      0x8410
#define    VIOLET   0x91D4


//End color


//Function definition
void lcd_init(void);
void lcd_cmd(int8 cmd);
void lcd_data(int8 data);
void lcd_data16(int16 data);
void Load_image(char x1, char y1);
void lcd_const(unsigned int8 *buffer, unsigned int8 count);
void lcd_cls(void);
void fill_screen(int16);
void fill_region(int8,int8,int16,int16,int16);
void fill_box(int8,int8,int16,int16,int16);
void lcd_setarea(int8 startx, int8 endx, int8 starty, int8 endy);
//!void gclcd_contrast(int8 contrast);
//!void gclcd_img(unsigned int8 x, unsigned int8 y);
//!void gclcd_font(void);
void  lcd_putc(char c);
void lcd_newline(void);
void lcd_gotoxy(unsigned int8 x, unsigned int8 y);
//!void gclcd_pixel(unsigned int8 x, unsigned int8 y, int16 color);
//!void gclcd_line(int x1, int y1, int x2, int y2, int16 color);
//!void gclcd_bar(int x1, int y1, int x2, int y2, int width, int16 color);
//!void gclcd_rect(int x1, int y1, int x2, int y2, int width, int1 fill, int16 color);
//!void gclcd_circle(int x, int y, int radius, int width, int1 fill, int16 color);
//End Fnction

//Variable definition

 





unsigned int16 fcolor=0x0000;
unsigned int16 bcolor=0xffff;
unsigned int8 wight=5; //height/  width/
unsigned int8 height=8;
unsigned int8 c;
unsigned int8 i;

unsigned int8 xCoord=0;
unsigned int8 yCoord=0;
//End Variable

//-----------------------------//
//      lcd      //
//-----------------------------//


void lcd_wr(int8 buf )
  {
   int8 i=8;
  #bit test=buf.7  
  
   while(i,i--)
      {
   SDA=test;
   SCLK=1;
   SCLK=0;
   buf<<=1;
      }
  }


//-----------------------------//
//      lcd    //
//-----------------------------//

    
void lcd_cmd(int8 buf)
    {
     DC=0;
     lcd_wr(buf);
     lcd_wr(0);
     DC=1;
    }
    
//-----------------------------//
//      lcd     //
//-----------------------------//
  
    
void lcd_data(int8 buf)
    { 
     lcd_wr(buf);
     lcd_wr(0);
    }    





void lcd_data16(int16 buf)
    {
	 lcd_wr(buf>>8);    
	 lcd_wr(buf);   	       
    }    







void lcd_setarea(int8 startx, int8 endx, int8 starty, int8 endy)
{
   lcd_cmd(SD_CSET);
   lcd_data(8+starty);
   lcd_data(0x01);
   lcd_data(8+endy);
   lcd_data(0x01);
   lcd_cmd(SD_PSET);
   lcd_data(startx);
   lcd_data(endx);
   xCoord=startx;
   yCoord=starty;   
}

void lcd_init(void)
{
   TRISD=0;
   LATD=0;
   delay_ms(10);
   RST=1;         //  
   delay_ms(35);
   CS=0;
  lcd_cmd(DATCTL);
  lcd_data(0x2A);  // 0x2A=565 mode, 0x0A=666mode, 0x3A=444mode
  //lcd_data(0x0);
  CS=1;
  CS=0;

  lcd_cmd(DISCTL);
 ptr=&disctl_0;
  for (i=0; i<9; i++)
  {  
    lcd_data(*ptr++);
  }
  
  lcd_cmd(GCP64);
  ptr=&gcp64_0;
  for (i=0; i<29; i++)
  {
    lcd_data(*ptr++);
    lcd_data(0x00);
  }
  ptr=&gcp64_1;
  for (i=0; i<34; i++)
  {
    lcd_data(*ptr++);
    lcd_data(0x00);
  }

  lcd_cmd(GCP16);
  ptr=&gcp16_0;
  for (i=0; i<15; i++)
  {
    lcd_data(*ptr++);
  }
  

  lcd_cmd(GSSET);
  lcd_data(0x01);

  lcd_cmd(OSSEL);
  lcd_data(0x00);

  lcd_cmd(SLPOUT);
  
  //delay_ms(35);
  
  lcd_cmd(SD_CSET);
  lcd_data(0x08);
  lcd_data(0x01);
  lcd_data(0x8B);
  lcd_data(0x01);

  lcd_cmd(SD_PSET);
  lcd_data(0x00);
  lcd_data(0x8F);


  lcd_cmd(ASCSET);
  lcd_data(0x00);
  lcd_data(0xAF);
  lcd_data(0xAF);
  lcd_data(0x03);
    
 lcd_cmd(SCSTART);
 lcd_data(0x00);
 DC=0;
 //delay_ms(100);
 lcd_cmd(DISON);
  CS=1;


}

void fill_screen(int16 color)
{
  int16 i;
  CS=0;
  
  lcd_cmd(SD_CSET);
  lcd_data(0x08);  // start is 8, not 0
  lcd_data(0x01);
  lcd_data(0x8B);  // is 00x8B = 0x83+8
  lcd_data(0x01);

  lcd_cmd(SD_PSET);
  lcd_data(0x00);
  lcd_data(0xAF);
  
  lcd_cmd(RAMWR);

  // start data transmission  
  for (i=0; i<DISP_W*DISP_H; i++)
  {
   lcd_wr(color>>8);
   lcd_wr(color);
  }  
 lcd_cmd(NOP);
 CS=1;
   
}
void fill_region(int8 x ,int8 y,int16 reg_wight,int16 reg_height,int16 color)
 
  {
  int16 i;
  CS=0;
   lcd_setarea(x,x+(reg_wight),y,y+(reg_height));
   
    lcd_cmd(RAMWR);
  // start data transmission 
  for (i=0; i<reg_wight*(reg_height+1); i++)
  {
   lcd_wr(color>>8);
   lcd_wr(color);
  } 
 
   CS=1;
  } 


void fill_box(int8 x ,int8 y,int16 wight,int16 height,int16 color)
 
  {
  int16 j;
  int16 i;
  CS=0;
   lcd_setarea(x,x+(wight-1),y,y+(height-1));
   
    lcd_cmd(RAMWR);
  // start data transmission 
  for(j=0;j<120;j++)
  {
  for (i=0; i<2; i++)
  {
   lcd_wr(color>>8);
   lcd_wr(color);
  } 
   for (i=0; i<3; i++)
  {
   lcd_wr(0x0>>8);
   lcd_wr(0x0);
  } 
  
  } 
   lcd_cmd(NOP);
   CS=1;
  } 
/*
void Load_image(char x1, char y1)

{ 
	char y;
	char x;		 
   int16 i=2;
  CS=0;
for (y=y1; y!=lin[1]+y1;y++)  
{
for ( x=x1; x!=lin[0]+x1;x++)
{ 
 lcd_cmd(SD_CSET);
 lcd_data(0x8B-y);  
  lcd_data(0x01);
  lcd_data(0x8B);  
  //lcd_data(0x01);
  lcd_cmd(SD_PSET);
  lcd_data(x);
  lcd_data(0xAF); 
  lcd_cmd(RAMWR);  
  lcd_wr (lin[i]);
  lcd_wr (lin[i+1]);
  i=i+2;
}
} 
CS=1;  // deselect display    
}




void Load_image(char x, char y,ROM char*m)

{ 
   int16 x1;
   int16 y1;	 
   int16 i=2;
   CS=0;
    
  lcd_setarea(x,(x+m[0]-1),y,(y+m[1]-1));
  lcd_cmd(RAMWR); 
  for ( i=2; i<((make16(0,m[0])* make16(0,m[1]))*2+2);)
{  
  lcd_wr(m[i]);
  lcd_wr(m[i+1]);
  i=i+2;
}
    CS=1;  // deselect display    
}
*/

void Load_image(char x1, char y1,ROM char*m)

{ 
	char y;
	char x;	
    int16 i=2;
   
  CS=0;
  lcd_setarea(x1,(x1+m[0]-1),y1,(y1+m[1]-1));
  lcd_cmd(RAMWR); 
   
for (y=0; y!=(m[1]&0xff);y++)  
{
for ( x=0; x!=(m[0]&0xff);x++)
{   
  lcd_wr (m[i]);
  lcd_wr (m[i+1]);
  i=i+2;
}
} 
CS=1;  // deselect display    
}
void  lcd_putc(char c)
{  
   
   int8 temp=0;
   int8 i=0;
   int8 j=0;
   CS=0;
   
   if(c == '\n') 
	   {
	   lcd_newline();
	   return;
	   }
   if(c == '\f') 
   {
	   //lcd_cls();
	   return;
	  }
	   
   if(c < 32)
	   {
		    c=' ';
		  }  	
   if(c>=192)c-=96;
   else c-=32;
   lcd_setarea(xCoord,xCoord+wight,yCoord,yCoord+height-1);
    lcd_cmd(RAMWR);
    for(i=0;i<=(wight-1);i++)    
      {
	    temp=Font5x8[c][i];
	     for(j=0;j<=(height-1);j++)
	        { 
		       if(bit_test(temp,7)) 
			       {
			       //lcd_wr(fcolor>>8);
			       //lcd_wr(fcolor);
			       lcd_data16(fcolor);
			       }
			   else  
			   { 
				   //lcd_wr(bcolor>>8);
			       //lcd_wr(bcolor);
			       lcd_data16(bcolor);
				  } 
			   				temp<<=1;
		     }
	  }
	   

	 	
	  CS=1;   
	  xCoord+=(wight+1);
}






void lcd_newline(void)
{
	if(yCoord+wight < 67)
      lcd_gotoxy(0, yCoord+wight);
   else
      lcd_gotoxy(0,0);
}		     

void lcd_gotoxy(unsigned int8 x, unsigned int8 y)
{
	xCoord=x;
	yCoord=y;
}	
